var app = require('express')();
var http = require('http').Server(app);
var io = require('socket.io')(http);
const five = require('johnny-five');
const Oled = require('oled-js');
var temporal = require('temporal');
var pngtolcd = require('png-to-lcd');
var font = require('oled-font-5x7');

app.get('/', function(req, res){
	res.sendFile(__dirname + '/index.html');
});

http.listen(3000, function(){
  console.log('listening on *:3000');
});


//OLED Board
const board = new five.Board();
const width = 128;
const height = 64;

var screen;


//WEBSOCKET
io.on('connection', function(socket){
  console.log('a user connected');

  socket.on('chat message', function(msg){

  	if(msg =='on') {
  		console.log("turn on board")
  		turnOn(screen);
  	}

  	if(msg =='off') {
  		console.log("turn off board")
  		turnOff(screen);
  	}
  // console.log('message: ' + instruct);
  });
});


//OLED
board.on('ready', function () {
 	
 	console.log('yay!!');

 	const options = {
 		width,
 		height,
 		slavePin: 12
 	};

 	screen = new Oled(board, five, options)
});

function turnOn() {
	screen.turnOnDisplay();
}

function turnOff() {
	screen.turnOffDisplay();
}


//BOARD NATIVE CODE TEST
// board.on('ready', function() {
//   console.log('Connected to Arduino, ready.');

//   // I2C va USB
//   // var opts = {
//   //   width: 128,
//   //   height: 64, 
//   //   address: 0x3D
//   // };

//   // SPI via USB
//   var opts = {
//     width: 128,
//     height: 64, 
//     slavePin: 12
//   };

//   // SPI Microview via USB
//   // var opts = {
//   //   width: 64,
//   //   height: 48, 
//   //   microview: true
//   // };

//   var oled = new Oled(board, five, opts);

//   test(oled);
// });

//TEST DISPLAYS
// function test(oled) {

//   // if it was already scrolling, stop
//   oled.stopScroll();

//   // clear first just in case
//   oled.update();

//   // make it prettier 
//   oled.dimDisplay(true);


//   temporal.queue([
//     {
//       delay: 10000,
//       task: function() {
//         // draw some test pixels
//       oled.turnOffDisplay();
//       console.log('off1')
//       }
//     },

//      {
//       delay: 10000,
//       task: function() {
//         // draw some test pixels
//       oled.turnOnDisplay();
//       console.log('on1')
//       }
//     },
    
//     {
//       delay: 10000,
//       task: function() {
//         // draw some test pixels
//       oled.turnOffDisplay();
//       console.log('off2')
//       }
//     },

//          {
//       delay: 10000,
//       task: function() {
//         // draw some test pixels
//       oled.turnOnDisplay();
//       console.log('on1')
//       }
//     }
    
//   ]);
// }
